;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME:zeroun
;
; PURPOSE:renvoie un vecteur ou une matrice constitue de o et de 1 en
; alternance
;
; CATEGORY:function, matrices
;
; CALLING SEQUENCE:resultat=zeroun(n1 [,n2])
;
; INPUTS:
;	n1=nombre d'elements dans la premiere dimension
;	n2=nombre d'elements dans la deuxieme dimension
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:resultat
;
; COMMON BLOCKS:
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY: Sebastien Masson (smasson@lodyc.jussieu.fr)
;                       1/12/98
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
function zeroun, n1,n2
;
  compile_opt idl2, strictarrsubs
;
   CASE N_PARAMS() OF
      1:return, findgen(n1) mod 2
      2:BEGIN 
         if fix(n1/2) EQ n1/2. then BEGIN ;nombre pair de colonnes
            res = findgen(n1+1,n2) mod 2
            return, res[0:n1-1, *]
         ENDIF ELSE return, findgen(n1,n2) mod 2 ;nombre impair de colonnes
      END
      else: return,  report('Mauvais nombre de parametre dans l''appel de ZEROUN')
   endcase            
end
