;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME: undefine
;
; PURPOSE: effacer une variable
;           meme chose que delvar mais utiulisable ds un programme et
;           utilisable que pour une variable a la fois
;
; CATEGORY: 
;
; CALLING SEQUENCE: UNDEFINE, varname  
; 
; INPUTS: varname: la variable a detruire
;
; EXAMPLE:
;
;    IDL> a=1
;    IDL> undefine,a
;    % Compiled module: UNDEFINE.
;    IDL> help, a
;    A               UNDEFINED = <Undefined>
;
; MODIFICATION HISTORY: trouve sur la page web de D.Fanning 
; http://www.dfanning.com :
;QUESTION: How do I make an IDL variable have a type "undefined"? 
;ANSWER: At the main IDL level you can use the IDL procedure DELVAR to
;delete an IDL variable and make it undefined. Inside of procedures
;and functions, I use this little program named UNDEFINE that I got
;from Andrew Cool at the DSTO High Frequency Radar Division in
;Adelaide, Australia.
;
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
   PRO UNDEFINE, varname  
;
  compile_opt idl2, strictarrsubs
;
   tempvar = SIZE(TEMPORARY(varname))
   END

